<?php
rg_log("/inc/user/repo/bug/main");

$_bug_body = "";

$_more['can_save'] = $rg_ui['uid'] > 0 ? 1 : 0;

$_op = empty($paras) ? "list" : array_shift($paras);
switch ($_op) {
case 'search':
	include($INC . "/user/repo/bug/search/search.php");
	$_bug_body .= $_bug_search;
	break;

case 'add':
	include($INC . "/user/repo/bug/add/add.php");
	$_bug_body .= $_bug_add;
	break;

case 'list': /* list */
	$_search = empty($paras) ? "All" : array_shift($paras);

	$_url = rg_re_repopage($ui, $ri['name']) . "/bug";

	// Somebody pressed "Remove" button?
	if (rg_var_uint("remove") == 1) {
		$token = rg_var_str("token");
		if (!rg_token_valid($db, $sid, $token)) {
			$_bug_body .= "Error: invalid token. Try again."; // TODO
			exit(1); // security_violation!
		}

		$r = rg_bug_search_remove($db, $ri['repo_id'], $rg_ui['uid'],
			$_search);
		if ($r === FALSE)
			$_bug_body .= "Error: cannot delete search!"; // TODO
	}

	$r = rg_bug_search_load_all($db, $ri['repo_id'], $rg_ui['uid'], $_url);
	if ($r === FALSE) {
		$_bug_body .= "Error: cannot load all searches!"; // TODO
	} else {
		$_bug_body .= rg_template_table("repo/bug/search/list",
				$r, $_more);
	}

	$filter = rg_bug_search_load($db, $ri['repo_id'], $rg_ui['uid'], $_search);
	if ($filter === FALSE) {
		$_bug_body .= "Error: cannot load search!"; // TODO
		$filter = array();
	}

	if (isset($filter['name']))
		$_more['search_name'] = $filter['name'];

	$r = rg_bug_search($db, $_more['url_repo'], $ri['repo_id'],
		$rg_ui['uid'], $filter);
	if ($r === FALSE)
		$_bug_body .= "Error: Cannot search bugs!"; // TODO: do something OK here!
	else
		$_bug_body .= $r;

	// Show remove for custom search
	if (isset($filter['standard']) && ($filter['standard'] == 0)) {
		$_remove_more = $_more;
		$_remove_more['rg_action'] = $_url . "/list/" . $filter['name'];
		$_remove_more['rg_form_token'] = rg_token_get($db, $sid);
		$_remove_more['search_remove_errmsg'] = "";
		$_bug_body .= rg_template("repo/bug/search/remove.html",
			$_remove_more);
	}
	break;

default: // go directly to a bug
	$bug_id = intval($_op);
	if ($bug_id == 0) {
		rg_log("BAD, invalid op=$_op!");
	} else {
		include($INC . "/user/repo/bug/show.php");
		$_bug_body .= $_bug_show;
	}
}

$_more['HTML:bug_body'] = $_bug_body;
?>
