<?php
rg_log("/inc/user/repo/edit/edit");

$_edit = "";

$errmsg = array();

$_show_form = 1;
if ($doit == 1) {
	if (!rg_token_valid($db, $sid, $token)) {
		$_edit .= "Invalid token. Try again.";
		return;
	}

	$repo_id = rg_var_uint("repo_id");
	$master_repo_id = 0;
	$name = rg_var_str("name");
	$max_commit_size = rg_var_uint("max_commit_size");
	$max_users = rg_var_uint("max_users");
	$description = rg_var_str("description");
	$rights = @rg_rights_a2s($_REQUEST['rights']);

	do {
		// lookup user
		$_ui = rg_user_info($db, 0, $rr['user'], "");
		if ($_ui['ok'] != 1) {
			$errmsg[] = "internal error";
			break;
		} else if ($_ui['exists'] != 1) {
			$errmsg[] = "user <b>$user</b> does not exists";
			break;
		}

		$ri['name'] = $name; // TODO: filter name!
		$ri['max_commit_size'] = $max_commit_size;
		$ri['description'] = $description; // TODO: filter
		$ri['default_rights'] = $rights; // TODO: filter
		$ri['max_users'] = $max_users;
		$_r = rg_repo_update($db, $_ui['username'], $ri);
		if ($_r === FALSE) {
			$errmsg[] = rg_repo_error();
			break;
		}

		$_edit .= "The repository was updated with success!";
		$_show_form = 0;
	} while (0);
} else {
	// load variables
	$repo_id = $ri['repo_id'];
	$master_repo_id = 0;
	$name = $ri['name'];
	$rights = $ri['default_rights'];
	$max_commit_size = $ri['max_commit_size'];
	$max_users = $ri['max_users'];
	$description = $ri['description'];
}

if ($_show_form == 1) {
	$_action = "Update";
	include($INC . "/repo/repo.form.php");
	$_edit .= $_form;
}

?>
