<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = "../inc";
require_once($INC . "/init.inc.php");
require_once($INC . "/git.inc.php");

rg_log_set_file("git.log");

$rg_scripts = "/usr/share/rocketgit";

echo "[*] Checking if git-init works...\n";
$r = rg_git_init("git.tmp");
if ($r !== TRUE) {
	echo "Cannot run rg_git_init (" . rg_git_error() . ")!\n";
	exit(1);
}

echo "[*] Populate repo...\n";
file_put_contents("git.tmp/a", "aaa");
system("cd git.tmp; git commit -a -m \"aa\"; git checkout -n b1");
// This is a bare repo! Could not work!

echo "[*] Testing rg_git_refs...\n";
$refs = rg_git_refs("git.tmp");
print_r($refs);

system("rm -rf git.tmp");

echo "git: OK\n";
?>
